## trouble with graph edge representation - algorithm

I'm pursuing an algorithms course and currently we're learning network flow algorithms and hence naturally, we'll be dealing with graphs.
The issue I'm facing is with an assignment question that we've recieved, where we're supposed to implement the ford-fulkerson algorithm.
The input parameters seem very bizzare for creating the graph to perform the algorithm on-
for instance, here is a sample input test case
{Here, N is the number of vertices and M is the number of edges}
N = 5, M = 4
Starting vertex = 1
Ending vertex = 5
Edges[]= {{1,2,1},{3,2,2},{4,2,3},{2,5,5}}
It is the last line that confuses me. What representation of a weighted graph exactly is this? I've tried looking this up online but everyone just uses adjacency matrices.
As I've mentioned, I'm not able to understand how we go about inputting a graph here with this bizarre input format.
Thank you in advance

## Related

### Which algorithm should match this specific Graph

specific question here. Suppose you have a graph where each vertice specifies how many connections they must have to another vertices and the following rules/properties apply: 1- The graph can be incomplete (no need to every vertice to have a connection with every other) 2- There can be two connections between two vertices only if they are in opposite directions (e.g: A points do B, B points to A). 3- Suppose they are on a 2D plane, there can be no crossing of connections (not even tangents). 4- Theres no interest for the shortest path, just respecting the properties and knowing if the solution is unique or not. 5- There can be no possible solution EDIT: Alright guys sorry for not being specific. I'll try to clarify my point here: what I want to do is given a number of vertices, know if a graph is connected (if all the points have at least a connection to the graph). The vertices given can be impossible to make a graph of it so I want to know if there's is a solution, if the solution is unique or not or (worst case scenario) if there is no possible solution. I think that clarifies point 4 and 5. The graph is undirected, the connections can Not curve, only straight lines.The Nodes (vertices) are fixed, we have their position from or W/E input. I wanted to know the best approach and I've been researching and it is a connectivity problem, though maybe some specific alg may be more efficient doing this task. That's all, sorry for late reply EDIT2: Alright guys would the problem be different if we think that each vertice is on a row and column of a plane matrix and they can only connect with other Vertices on the same column or row? So it would be just 90/180/270/360 straight connections. This would hugely shorten the possibilities right?

I am going to assume that the question is: Given the degree of each vertex, work out a graph that passes all the constraints given. I think you can reduce this to a very large integer programming problem - linear constraints, but with the variables required to be integers (in fact either 0 or 1), which makes the problem much more difficult than ordinary linear programming. Let the unknowns be of the form Xij, where Xij is 1 if there is an edge from node i to node j, and 0 otherwise. The requirements on the number of connections then amount to requirements of the form SUM_{all i}Xij = K for some K dependent on the requirement. The requirement that the graph is planar reduces to the requirement that the graph not contain two known graphs as subgraphs - https://en.wikipedia.org/wiki/Graph_minor. Each possible subgraph then produces a constraint such as X01 + X02 + ... < 5 - there will be a huge number of these constraints - so large that for large number of nodes simply producing all the constraints may be too expensive to be practical, let alone solving them. The number of constraints goes up as at least the 6th power of the number of nodes. However this is polynomial, so theoretically practical to write down the MIP to be solved - so perhaps this is better than no algorithm at all.

Assuming that you are asking us to: Find out if it is possible to generate one-or-more directed planar graphs such that each vertex has a given out-degree (not necessarily the same out-degree per vertex). Let's also assume that you want the graph to be connected. If there are n vertices and the vertices have degrees d_1 ... d_n then for vertex i there are C(n-1,d_i) = (n-1)!/((d_i)!*(n-1-d_i)!) possible combinations of out-edges from that vertex. Taking the product of all these combinations over all the vertices will give you the upper bound on the number of possible graphs. The naive approach is: Generate all possible graphs. Filter the graphs to only have connected graphs. Run a planarity test on the graph to determine if it is planar (you can consider the graph to be undirected in this step); discard if it isn't. Profit!

### What can be a correct approach for SPOJ COURIER

I am trying to solve COURIER problem on spoj. I am able to understand that I have to solve TSP for this with dynamic programming approach but I am unable to exactly understand that whether my approach for handling multiple parcel between same pair of cities is correct or not. My pseudocode will be somewhat as following: 1) Use floyd warshall to find all pair shortest path in O(n^3). Some pair of cities are connected by more than one roads, I can just keep the shortest one for my undirected graph. 2) Add the shortest cost for each request start to end. 3) Create a new directed graph for each of 12 requests and homecity. The node of this new graph will be a merge of each request's source and destination. The edge weight between a->b can be calculated by shortest path between 'a' request's destination to 'b' request's source.I am thinking of duplicating the pairs if I have multiple request between them. 4) Use a TSP DP to solve this new undirected 13 city TSP problem. O(n^2 2^n) would come around 1384448. Not sure whether this will time out for multiple test cases. Can you please give your inputs as am I complicating the problem with my approach of creating this new directed graph? I am not using the information that there are only 5 such different requests. I know I can coed this up and know but I want to get some suggestions on solution first.

Nice problem. After doing point 1), you can ignore all cities that are not source or address of delivery. Therefore you have 10 cities where the traveler currently is and 2^12 possible combinations of tasks that are still to complete. You can just do DP with two arguments: current city and deliveries to complete, that you can store with bit mask. EDIT: As mentioned you have two arguments: p which tracks current position and mask which tracks which visits you have already done. Mask works as bit mask: http://en.wikipedia.org/wiki/Mask_%28computing%29 You start with mask 0, which in binary is 000000000000. When you do for example 5th requested travel you change mask to: 000000010000 etc. You start by calling f(p=0, mask=0). When you are solving f(p, mask) you have two options. You can move to any other city p2. You can make travel p -> p2 if this is one of travels you haven't done. Out of all these options you have to choose the best one. This problem is quite tricky and I would suggest first solving easier problems using bit-masks to begin with. You can find some here: http://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&category=778

I don't know if you need the answer now or not, but here is what I did : Initially your approach is correct, you have to apply floyd-warshall to get shortest distance b/w all the pairs. Now it is a classic dp+bitmask problem. There are only 12 operations, you have to arrange these 12 operations such that you get the minimum. This can be done by using bitmask : 000000000000 You have these 12 states => if you pick one, you can't pick it again. And since (2^12=4096) it will not be difficult to store such a number. My dp states were very straight forward : 'mask number' and 'parent' PARENT-> the last operation you have done dp[mask][par] Hope this will help

### Data Structures / undirected graphs and Dijkstra's algorithm

I am stuck on a two part practice problem regarding the subjects mentioned in the title. The first part of the question asks: By considering the complete graph with n verticies, show that the maximum number of simple paths between two verticies is O((n-1)!). (I am assuming I am supposed to show this somehow with a formal definition) The second portion of the questions asks: Give an example where Dijkstra's algorithm gives the wrong answer in the presence of a negative edge but no negative cost cycles. Thanks for any help!

### Find the extreme for priority function / alphabet order

We have an array of elements a1,a2,...aN from an alphabet E. Assuming |N| >> |E|. For each symbol of the alphabet we define an unique integer priority = V(sym). Let's define V{i} := V(symbol(ai)) for the simplicity. How can I find the priority function V for which: Count(i)->MAX | V{i} < V{i+1} In other words, I need to find the priorities / permutation of the alphabet for which the number of positions i, satisfying the condition V{i}<V{i+1}, is maximum. Edit-1: Please, read carefully. I'm given an array ai and the task is to produce a function V. It's not about sorting the input array with a priority function. Edit-2: Example E = {a,b,c}; A = 'abcab$'; (here $ = artificial termination symbol, V{$}=+infinity) One of the optimal priority functions is: V{a}=1,V{b}=2,V{c}=3, which gives us the following signs between array elements: a<b<c>a<b<$, resulting in 4 '<' signs of 5 total.

If elements could not have tied priorities, this would be trivial. Just sort by priority. But you can have equal priorities. I would first sort the alphabet by priority. Then I'd extract the longest rising subsequence. That is the start of your answer. Extract the longest rising subsequence from what remains. Append that to your answer. Repeat the extraction process until the entire alphabet has been extracted. I believe that this gives an optimal result, but I haven't tried to prove it. If it is not perfectly optimal, it still will be pretty good. Now that I think I understand the problem, I can tell you that there is no good algorithm to solve it. To see this let us first construct a directed graph whose vertices are your elements, and whose edges indicate how many times one element immediately preceeded another. You can create a priority function by dropping enough edges to get a directed acyclic graph, use the edges to create a partially ordered set, and then add order relations until you have a full linear order, from which you can trivially get a priority function. All of this is straightforward once you have figured out which edges to drop. Conversely given that directed graph and your final priority function, it is easy to figure out which set of edges you had to decide to drop. Therefore your problem is entirely equivalent to figuring out a minimal set of edges you need to drop from athat directed graph to get athat directed acyclic graph. However as http://en.wikipedia.org/wiki/Feedback_arc_set says, this is a known NP hard problem called the minimum feedback arc set. begin update It is therefore very unlikely that there is a good algorithm for the graphs you can come up with. end update If you need to solve it in practice, I'd suggest going for some sort of greedy algorithm. It won't always be right, but it will generally give somewhat reasonable results in reasonable time. Update: Moron is correct, I did not prove NP-hard. However there are good heuristic reasons to believe that the problem is, in fact, NP-hard. See the comments for more.

There's a trivial reduction from Minimum Feedback Arc Set on directed graphs whose arcs can be arranged into an Eulerian path. I quote from http://www14.informatik.tu-muenchen.de/personen/jacob/Publications/JMMN07.pdf : To the best of our knowledge, the complexity status of minimum feedback arc set in such graphs is open. However, by a lemma of Newman, Chen, and Lovász [1, Theorem 4], a polynomial algorithm for [this problem] would lead to a 16/9 approximation algorithm for the general minimum feedback arc set problem, improving over the currently best known O(log n log log n) algorithm [2]. Newman, A.: The maximum acyclic subgraph problem and degree-3 graphs. In: Proceedings of the 4th International Workshop on Approximation Algorithms for Combinatorial Optimization Problems, APPROX. LNCS (2001) 147–158 Even,G.,Naor,J.,Schieber,B.,Sudan,M.:Approximatingminimumfeedbacksets and multi-cuts in directed graphs. In: Proceedings of the 4th International Con- ference on Integer Programming and Combinatorial Optimization. LNCS (1995) 14–28

### Algorithm to find two points furthest away from each other

Im looking for an algorithm to be used in a racing game Im making. The map/level/track is randomly generated so I need to find two locations, start and goal, that makes use of the most of the map. The algorithm is to work inside a two dimensional space From each point, one can only traverse to the next point in four directions; up, down, left, right Points can only be either blocked or nonblocked, only nonblocked points can be traversed Regarding the calculation of distance, it should not be the "bird path" for a lack of a better word. The path between A and B should be longer if there is a wall (or other blocking area) between them. Im unsure on where to start, comments are very welcome and proposed solutions are preferred in pseudo code. Edit: Right. After looking through gs's code I gave it another shot. Instead of python, I this time wrote it in C++. But still, even after reading up on Dijkstras algorithm, the floodfill and Hosam Alys solution, I fail to spot any crucial difference. My code still works, but not as fast as you seem to be getting yours to run. Full source is on pastie. The only interesting lines (I guess) is the Dijkstra variant itself on lines 78-118. But speed is not the main issue here. I would really appreciate the help if someone would be kind enough to point out the differences in the algorithms. In Hosam Alys algorithm, is the only difference that he scans from the borders instead of every node? In Dijkstras you keep track and overwrite the distance walked, but not in floodfill, but thats about it?

Assuming the map is rectangular, you can loop over all border points, and start a flood fill to find the most distant point from the starting point: bestSolution = { start: (0,0), end: (0,0), distance: 0 }; for each point p on the border flood-fill all points in the map to find the most distant point if newDistance > bestSolution.distance bestSolution = { p, distantP, newDistance } end if end loop I guess this would be in O(n^2). If I am not mistaken, it's (L+W) * 2 * (L*W) * 4, where L is the length and W is the width of the map, (L+W) * 2 represents the number of border points over the perimeter, (L*W) is the number of points, and 4 is the assumption that flood-fill would access a point a maximum of 4 times (from all directions). Since n is equivalent to the number of points, this is equivalent to (L + W) * 8 * n, which should be better than O(n2). (If the map is square, the order would be O(16n1.5).) Update: as per the comments, since the map is more of a maze (than one with simple obstacles as I was thinking initially), you could make the same logic above, but checking all points in the map (as opposed to points on the border only). This should be in order of O(4n2), which is still better than both F-W and Dijkstra's. Note: Flood filling is more suitable for this problem, since all vertices are directly connected through only 4 borders. A breadth first traversal of the map can yield results relatively quickly (in just O(n)). I am assuming that each point may be checked in the flood fill from each of its 4 neighbors, thus the coefficient in the formulas above. Update 2: I am thankful for all the positive feedback I have received regarding this algorithm. Special thanks to #Georg for his review. P.S. Any comments or corrections are welcome.

Follow up to the question about Floyd-Warshall or the simple algorithm of Hosam Aly: I created a test program which can use both methods. Those are the files: maze creator find longest distance In all test cases Floyd-Warshall was by a great magnitude slower, probably this is because of the very limited amount of edges that help this algorithm to achieve this. These were the times, each time the field was quadruplet and 3 out of 10 fields were an obstacle. Size Hosam Aly Floyd-Warshall (10x10) 0m0.002s 0m0.007s (20x20) 0m0.009s 0m0.307s (40x40) 0m0.166s 0m22.052s (80x80) 0m2.753s - (160x160) 0m48.028s - The time of Hosam Aly seems to be quadratic, therefore I'd recommend using that algorithm. Also the memory consumption by Floyd-Warshall is n2, clearly more than needed. If you have any idea why Floyd-Warshall is so slow, please leave a comment or edit this post. PS: I haven't written C or C++ in a long time, I hope I haven't made too many mistakes.

It sounds like what you want is the end points separated by the graph diameter. A fairly good and easy to compute approximation is to pick a random point, find the farthest point from that, and then find the farthest point from there. These last two points should be close to maximally separated. For a rectangular maze, this means that two flood fills should get you a pretty good pair of starting and ending points.

I deleted my original post recommending the Floyd-Warshall algorithm. :( gs did a realistic benchmark and guess what, F-W is substantially slower than Hosam Aly's "flood fill" algorithm for typical map sizes! So even though F-W is a cool algorithm and much faster than Dijkstra's for dense graphs, I can't recommend it anymore for the OP's problem, which involves very sparse graphs (each vertex has only 4 edges). For the record: An efficient implementation of Dijkstra's algorithm takes O(Elog V) time for a graph with E edges and V vertices. Hosam Aly's "flood fill" is a breadth first search, which is O(V). This can be thought of as a special case of Dijkstra's algorithm in which no vertex can have its distance estimate revised. The Floyd-Warshall algorithm takes O(V^3) time, is very easy to code, and is still the fastest for dense graphs (those graphs where vertices are typically connected to many other vertices). But it's not the right choice for the OP's task, which involves very sparse graphs.

Raimund Seidel gives a simple method using matrix multiplication to compute the all-pairs distance matrix on an unweighted, undirected graph (which is exactly what you want) in the first section of his paper On the All-Pairs-Shortest-Path Problem in Unweighted Undirected Graphs [pdf]. The input is the adjacency matrix and the output is the all-pairs shortest-path distance matrix. The run-time is O(M(n)*log(n)) for n points where M(n) is the run-time of your matrix multiplication algorithm. The paper also gives the method for computing the actual paths (in the same run-time) if you need this too. Seidel's algorithm is cool because the run-time is independent of the number of edges, but we actually don't care here because our graph is sparse. However, this may still be a good choice (despite the slightly-worse-than n^2 run-time) if you want the all pairs distance matrix, and this might also be easier to implement and debug than floodfill on a maze. Here is the pseudocode: Let A be the nxn (0-1) adjacency matrix of an unweighted, undirected graph, G All-Pairs-Distances(A) Z = A * A Let B be the nxn matrix s.t. b_ij = 1 iff i != j and (a_ij = 1 or z_ij > 0) if b_ij = 1 for all i != j return 2B - A //base case T = All-Pairs-Distances(B) X = T * A Let D be the nxn matrix s.t. d_ij = 2t_ij if x_ij >= t_ij * degree(j), otherwise d_ij = 2t_ij - 1 return D To get the pair of points with the greatest distance we just return argmax_ij(d_ij)

Finished a python mockup of the dijkstra solution to the problem. Code got a bit long so I posted it somewhere else: http://refactormycode.com/codes/717-dijkstra-to-find-two-points-furthest-away-from-each-other In the size I set, it takes about 1.5 seconds to run the algorithm for one node. Running it for every node takes a few minutes. Dont seem to work though, it always displays the topleft and bottomright corner as the longest path; 58 tiles. Which of course is true, when you dont have obstacles. But even adding a couple of randomly placed ones, the program still finds that one the longest. Maybe its still true, hard to test without more advanced shapes. But maybe it can at least show my ambition.

Ok, "Hosam's algorithm" is a breadth first search with a preselection on the nodes. Dijkstra's algorithm should NOT be applied here, because your edges don't have weights. The difference is crucial, because if the weights of the edges vary, you need to keep a lot of options (alternate routes) open and check them with every step. This makes the algorithm more complex. With the breadth first search, you simply explore all edges once in a way that garantuees that you find the shortest path to each node. i.e. by exploring the edges in the order you find them. So basically the difference is Dijkstra's has to 'backtrack' and look at edges it has explored before to make sure it is following the shortest route, while the breadth first search always knows it is following the shortest route. Also, in a maze the points on the outer border are not guaranteed to be part of the longest route. For instance, if you have a maze in the shape of a giant spiral, but with the outer end going back to the middle, you could have two points one at the heart of the spiral and the other in the end of the spiral, both in the middle! So, a good way to do this is to use a breadth first search from every point, but remove the starting point after a search (you already know all the routes to and from it). Complexity of breadth first is O(n), where n = |V|+|E|. We do this once for every node in V, so it becomes O(n^2).

Your description sounds to me like a maze routing problem. Check out the Lee Algorithm. Books about place-and-route problems in VLSI design may help you - Sherwani's "Algorithms for VLSI Physical Design Automation" is good, and you may find VLSI Physical Design Automation by Sait and Youssef useful (and cheaper in its Google version...)

If your objects (points) do not move frequently you can perform such a calculation in a much shorter than O(n^3) time. All you need is to break the space into large grids and pre-calculate the inter-grid distance. Then selecting point pairs that occupy most distant grids is a matter of simple table lookup. In the average case you will need to pair-wise check only a small set of objects. This solution works if the distance metrics are continuous. Thus if, for example there are many barriers in the map (as in mazes), this method might fail.